package ru.dbotthepony.kommons.gson

import com.google.gson.TypeAdapter
import com.google.gson.stream.JsonReader
import com.google.gson.stream.JsonWriter
import ru.dbotthepony.kommons.vector.Vector2i
import ru.dbotthepony.kommons.util.AABBi

object AABBiTypeAdapter : TypeAdapter<AABBi>() {
	override fun write(out: JsonWriter, value: AABBi) {
		`out`.beginArray()
		`out`.value(value.mins.x)
		`out`.value(value.mins.y)
		`out`.value(value.maxs.x)
		`out`.value(value.maxs.y)
		`out`.endArray()
	}

	override fun read(`in`: JsonReader): AABBi {
		`in`.beginArray()
		val (x1, x2) = Vector2i(`in`.nextInt(), `in`.nextInt())
		val (y1, y2) = Vector2i(`in`.nextInt(), `in`.nextInt())
		`in`.endArray()

		val xMins = x1.coerceAtMost(x2)
		val xMaxs = x1.coerceAtLeast(x2)

		val yMins = y1.coerceAtMost(y2)
		val yMaxs = y1.coerceAtLeast(y2)

		return AABBi(
			Vector2i(xMins, yMins),
			Vector2i(xMaxs, yMaxs),
		)
	}
}